## org.mortbay.jetty.servlet
Class ServletHttpResponse

    java.lang.Object
      |
      +--org.mortbay.jetty.servlet.ServletHttpResponse

All Implemented Interfaces:
  HttpServletResponse, ServletResponse

public class ServletHttpResponse
extends java.lang.Object
implements HttpServletResponse

Servlet Response Wrapper. This class wraps a Jetty HTTP response as a 2.2 Servlet response. Note that this wrapper is not synchronized and if a response is to be operated on by multiple threads, then higher level synchronizations may be required.

Version:
  $Id: ServletHttpResponse.java,v 1.36 2003/04/24 23:56:16 bretts Exp $
Author:
  Greg Wilkins (gregw)

Field Summary
`static int` `DISABLED`
`static int` `NO_OUT`
`static int` `OUTPUTSTREAM_OUT`
`static int` `WRITER_OUT`

Fields inherited from interface javax.servlet.http.HttpServletResponse

`SC_ACCEPTED, SC_BAD_GATEWAY, SC_BAD_REQUEST, SC_CONFLICT, SC_CONTINUE, SC_CREATED, SC_EXPECTATION_FAILED, SC_FORBIDDEN, SC_GATEWAY_TIMEOUT, SC_GONE, SC_HTTP_VERSION_NOT_SUPPORTED, SC_INTERNAL_SERVER_ERROR, SC_LENGTH_REQUIRED, SC_METHOD_NOT_ALLOWED, SC_MOVED_PERMANENTLY, SC_MOVED_TEMPORARILY, SC_MULTIPLE_CHOICES, SC_NO_CONTENT, SC_NON_AUTHORITATIVE_INFORMATION, SC_NOT_ACCEPTABLE, SC_NOT_FOUND, SC_NOT_IMPLEMENTED, SC_NOT_MODIFIED, SC_OK, SC_PARTIAL_CONTENT, SC_PAYMENT_REQUIRED, SC_PRECONDITION_FAILED, SC_PROXY_AUTHENTICATION_REQUIRED, SC_REQUEST_ENTITY_TOO_LARGE, SC_REQUEST_TIMEOUT, SC_REQUEST_URI_TOO_LONG, SC_REQUESTED_RANGE_NOT_SATISFIABLE, SC_RESET_CONTENT, SC_SEE_OTHER, SC_SERVICE_UNAVAILABLE, SC_SWITCHING_PROTOCOLS, SC_TEMPORARY_REDIRECT, SC_UNAUTHORIZED, SC_UNSUPPORTED_MEDIA_TYPE, SC_USE_PROXY`

Method Summary
`void` `addCookie(Cookie cookie)` Adds the specified cookie to the response.
`void` `addDateHeader(java.lang.String name, long value)` Adds a response header with the given name and date-value.
`void` `addHeader(java.lang.String name, java.lang.String value)` Adds a response header with the given name and value.
`void` `addIntHeader(java.lang.String name, int value)` Adds a response header with the given name and integer value.
`boolean` `containsHeader(java.lang.String name)` Returns a boolean indicating whether the named response header has already been set.
`java.lang.String` `encodeRedirectUrl(java.lang.String url)` Deprecated. As of version 2.1, use encodeRedirectURL(String url) instead
`java.lang.String` `encodeRedirectURL(java.lang.String url)` Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged.
`java.lang.String` `encodeUrl(java.lang.String url)` Deprecated. As of version 2.1, use encodeURL(String url) instead
`java.lang.String` `encodeURL(java.lang.String url)` Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged.
`void` `flushBuffer()` Forces any content in the buffer to be written to the client.
`int` `getBufferSize()` Returns the actual buffer size used for the response.
`java.lang.String` `getCharacterEncoding()` Returns the name of the charset used for the MIME body sent in this response.
`java.util.Locale` `getLocale()` Returns the locale assigned to the response.
`ServletOutputStream` `getOutputStream()` Returns a `ServletOutputStream` suitable for writing binary data in the response.
`java.io.PrintWriter` `getWriter()` Returns a `PrintWriter` object that can send character text to the client.
`boolean` `isCommitted()` Returns a boolean indicating if the response has been committed.
`void` `reset()` Clears any data that exists in the buffer as well as the status code and headers.
`void` `resetBuffer()` Clears the content of the underlying buffer in the response without clearing headers or status code.
`void` `sendError(int status)` Sends an error response to the client using the specified status code and clearing the buffer.
`void` `sendError(int status, java.lang.String message)` Sends an error response to the client using the specified status clearing the buffer.
`void` `sendRedirect(java.lang.String url)` Sends a temporary redirect response to the client using the specified redirect location URL.
`void` `setBufferSize(int size)` Sets the preferred buffer size for the body of the response.
`void` `setContentLength(int len)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
`void` `setContentType(java.lang.String contentType)` Sets the content type of the response being sent to the client.
`void` `setDateHeader(java.lang.String name, long value)` Sets a response header with the given name and date-value.
`void` `setHeader(java.lang.String name, java.lang.String value)` Sets a response header with the given name and value.
`void` `setIntHeader(java.lang.String name, int value)` Sets a response header with the given name and integer value.
`void` `setLocale(java.util.Locale locale)` Sets the locale of the response, setting the headers (including the Content-Type's charset) as appropriate.
`void` `setStatus(int status)` Sets the status code for this response.
`void` `setStatus(int status, java.lang.String message)` Deprecated. As of version 2.1 of the Servlet spec. To set a status code use `setStatus(int)`, to send an error with a description use `sendError(int, String)`. Sets the status code and message for this response.
`java.lang.String` `toString()`
`static ServletHttpResponse` `unwrap(ServletResponse response)` Unwrap a ServletResponse.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DISABLED

    public static final int DISABLED

See Also:
  Constant Field Values

### NO_OUT

    public static final int NO_OUT

See Also:
  Constant Field Values

### OUTPUTSTREAM_OUT

    public static final int OUTPUTSTREAM_OUT

See Also:
  Constant Field Values

### WRITER_OUT

    public static final int WRITER_OUT

See Also:
  Constant Field Values

Method Detail

### isCommitted

    public boolean isCommitted()

  Description copied from interface: `ServletResponse`
  Returns a boolean indicating if the response has been committed. A commited response has already had its status code and headers written.

  Specified by:
    `isCommitted` in interface `ServletResponse`
  Returns:
    a boolean indicating if the response has been committed
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.reset()`

### setBufferSize

    public void setBufferSize(int size)

  Description copied from interface: `ServletResponse`
  Sets the preferred buffer size for the body of the response. The servlet container will use a buffer at least as large as the size requested. The actual buffer size used can be found using `getBufferSize`.

  A larger buffer allows more content to be written before anything is actually sent, thus providing the servlet with more time to set appropriate status codes and headers. A smaller buffer decreases server memory load and allows the client to start receiving data more quickly.

  This method must be called before any response body content is written; if content has been written, this method throws an `IllegalStateException`.

  Specified by:
    `setBufferSize` in interface `ServletResponse`
  Parameters:
    `size` - the preferred buffer size
  See Also:
    `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### getBufferSize

    public int getBufferSize()

  Description copied from interface: `ServletResponse`
  Returns the actual buffer size used for the response. If no buffering is used, this method returns 0.

  Specified by:
    `getBufferSize` in interface `ServletResponse`
  Returns:
    the actual buffer size used
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### flushBuffer

    public void flushBuffer()
                     throws java.io.IOException

  Description copied from interface: `ServletResponse`
  Forces any content in the buffer to be written to the client. A call to this method automatically commits the response, meaning the status code and headers will be written.

  Specified by:
    `flushBuffer` in interface `ServletResponse`
    `java.io.IOException`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### resetBuffer

    public void resetBuffer()

  Description copied from interface: `ServletResponse`
  Clears the content of the underlying buffer in the response without clearing headers or status code. If the response has been committed, this method throws an `IllegalStateException`.

  Specified by:
    `resetBuffer` in interface `ServletResponse`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.isCommitted()`, `ServletResponse.reset()`

### reset

    public void reset()

  Description copied from interface: `ServletResponse`
  Clears any data that exists in the buffer as well as the status code and headers. If the response has been committed, this method throws an `IllegalStateException`.

  Specified by:
    `reset` in interface `ServletResponse`
  See Also:
    `ServletResponse.setBufferSize(int)`, `ServletResponse.getBufferSize()`, `ServletResponse.flushBuffer()`, `ServletResponse.isCommitted()`

### setLocale

    public void setLocale(java.util.Locale locale)

  Sets the locale of the response, setting the headers (including the Content-Type's charset) as appropriate. This method should be called before a call to `getWriter()`. By default, the response locale is the default locale for the server.

  Specified by:
    `setLocale` in interface `ServletResponse`
  Parameters:
    `locale` - the Locale of the response
  See Also:
    `getLocale()`

### getLocale

    public java.util.Locale getLocale()

  Description copied from interface: `ServletResponse`
  Returns the locale assigned to the response.

  Specified by:
    `getLocale` in interface `ServletResponse`
  See Also:
    `ServletResponse.setLocale(java.util.Locale)`

### addCookie

    public void addCookie(Cookie cookie)

  Description copied from interface: `HttpServletResponse`
  Adds the specified cookie to the response. This method can be called multiple times to set more than one cookie.

  Specified by:
    `addCookie` in interface `HttpServletResponse`
  Parameters:
    `cookie` - the Cookie to return to the client

### containsHeader

    public boolean containsHeader(java.lang.String name)

  Description copied from interface: `HttpServletResponse`
  Returns a boolean indicating whether the named response header has already been set.

  Specified by:
    `containsHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the header name
  Returns:
    `true` if the named response header has already been set; `false` otherwise

### encodeURL

    public java.lang.String encodeURL(java.lang.String url)

  Description copied from interface: `HttpServletResponse`
  Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. For example, if the browser supports cookies, or session tracking is turned off, URL encoding is unnecessary.

  For robust session tracking, all URLs emitted by a servlet should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

  Specified by:
    `encodeURL` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### encodeRedirectURL

    public java.lang.String encodeRedirectURL(java.lang.String url)

  Description copied from interface: `HttpServletResponse`
  Encodes the specified URL for use in the `sendRedirect` method or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. Because the rules for making this determination can differ from those used to decide whether to encode a normal link, this method is seperate from the `encodeURL` method.

  All URLs sent to the `HttpServletResponse.sendRedirect` method should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.

  Specified by:
    `encodeRedirectURL` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.
  See Also:
    `HttpServletResponse.sendRedirect(java.lang.String)`, `HttpServletResponse.encodeUrl(java.lang.String)`

### encodeUrl

    public java.lang.String encodeUrl(java.lang.String url)

  Deprecated. As of version 2.1, use encodeURL(String url) instead

  Specified by:
    `encodeUrl` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### encodeRedirectUrl

    public java.lang.String encodeRedirectUrl(java.lang.String url)

  Deprecated. As of version 2.1, use encodeRedirectURL(String url) instead

  Specified by:
    `encodeRedirectUrl` in interface `HttpServletResponse`
  Parameters:
    `url` - the url to be encoded.
  Returns:
    the encoded URL if encoding is needed; the unchanged URL otherwise.

### sendError

    public void sendError(int status,
                          java.lang.String message)
                   throws java.io.IOException

  Description copied from interface: `HttpServletResponse`
  Sends an error response to the client using the specified status clearing the buffer. The server defaults to creating the response to look like an HTML-formatted server error page containing the specified message, setting the content type to "text/html", leaving cookies and other headers unmodified. If an error-page declaration has been made for the web application corresponding to the status code passed in, it will be served back in preference to the suggested msg parameter.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendError` in interface `HttpServletResponse`
  Parameters:
    `status` - the error status code
    `message` - the descriptive message
  Throws:
    `java.io.IOException` - If an input or output exception occurs

### sendError

    public void sendError(int status)
                   throws java.io.IOException

  Description copied from interface: `HttpServletResponse`
  Sends an error response to the client using the specified status code and clearing the buffer.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendError` in interface `HttpServletResponse`
  Parameters:
    `status` - the error status code
  Throws:
    `java.io.IOException` - If an input or output exception occurs

### sendRedirect

    public void sendRedirect(java.lang.String url)
                      throws java.io.IOException

  Description copied from interface: `HttpServletResponse`
  Sends a temporary redirect response to the client using the specified redirect location URL. This method can accept relative URLs; the servlet container must convert the relative URL to an absolute URL before sending the response to the client. If the location is relative without a leading '/' the container interprets it as relative to the current request URI. If the location is relative with a leading '/' the container interprets it as relative to the servlet container root.

  If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.

  Specified by:
    `sendRedirect` in interface `HttpServletResponse`
  Parameters:
    `url` - the redirect location URL
  Throws:
    `java.io.IOException` - If an input or output exception occurs

### setDateHeader

    public void setDateHeader(java.lang.String name,
                              long value)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setDateHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header to set
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addDateHeader(java.lang.String, long)`

### setHeader

    public void setHeader(java.lang.String name,
                          java.lang.String value)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the header value
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addHeader(java.lang.String, java.lang.String)`

### setIntHeader

    public void setIntHeader(java.lang.String name,
                             int value)

  Description copied from interface: `HttpServletResponse`
  Sets a response header with the given name and integer value. If the header had already been set, the new value overwrites the previous one. The `containsHeader` method can be used to test for the presence of a header before setting its value.

  Specified by:
    `setIntHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the assigned integer value
  See Also:
    `HttpServletResponse.containsHeader(java.lang.String)`, `HttpServletResponse.addIntHeader(java.lang.String, int)`

### addDateHeader

    public void addDateHeader(java.lang.String name,
                              long value)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and date-value. The date is specified in terms of milliseconds since the epoch. This method allows response headers to have multiple values.

  Specified by:
    `addDateHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header to set
  See Also:
    `HttpServletResponse.setDateHeader(java.lang.String, long)`

### addHeader

    public void addHeader(java.lang.String name,
                          java.lang.String value)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and value. This method allows response headers to have multiple values.

  Specified by:
    `addHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the additional header value
  See Also:
    `HttpServletResponse.setHeader(java.lang.String, java.lang.String)`

### addIntHeader

    public void addIntHeader(java.lang.String name,
                             int value)

  Description copied from interface: `HttpServletResponse`
  Adds a response header with the given name and integer value. This method allows response headers to have multiple values.

  Specified by:
    `addIntHeader` in interface `HttpServletResponse`
  Parameters:
    `name` - the name of the header
    `value` - the assigned integer value
  See Also:
    `HttpServletResponse.setIntHeader(java.lang.String, int)`

### setStatus

    public void setStatus(int status)

  Description copied from interface: `HttpServletResponse`
  Sets the status code for this response. This method is used to set the return status code when there is no error (for example, for the status codes SC_OK or SC_MOVED_TEMPORARILY). If there is an error, and the caller wishes to invoke an defined in the web applicaion, the `sendError` method should be used instead.

  The container clears the buffer and sets the Location header, preserving cookies and other headers.

  Specified by:
    `setStatus` in interface `HttpServletResponse`
  Parameters:
    `status` - the status code
  See Also:
    `HttpServletResponse.sendError(int, java.lang.String)`

### setStatus

    public void setStatus(int status,
                          java.lang.String message)

  Deprecated. As of version 2.1 of the Servlet spec. To set a status code use `setStatus(int)`, to send an error with a description use `sendError(int, String)`. Sets the status code and message for this response.

  Specified by:
    `setStatus` in interface `HttpServletResponse`
  Parameters:
    `status` - the status code
    `message` - the status message

### getCharacterEncoding

    public java.lang.String getCharacterEncoding()

  Description copied from interface: `ServletResponse`
  Returns the name of the charset used for the MIME body sent in this response.

  If no charset has been assigned, it is implicitly set to `ISO-8859-1` (`Latin-1`).

  See RFC 2047 (http://ds.internic.net/rfc/rfc2045.txt) for more information about character encoding and MIME.

  Specified by:
    `getCharacterEncoding` in interface `ServletResponse`
  Returns:
    a `String` specifying the name of the charset, for example, `ISO-8859-1`

### getOutputStream

    public ServletOutputStream getOutputStream()

  Description copied from interface: `ServletResponse`
  Returns a `ServletOutputStream` suitable for writing binary data in the response. The servlet container does not encode the binary data.

  Calling flush() on the ServletOutputStream commits the response. Either this method or `ServletResponse.getWriter()` may be called to write the body, not both.

  Specified by:
    `getOutputStream` in interface `ServletResponse`
  Returns:
    a `ServletOutputStream` for writing binary data
  See Also:
    `ServletResponse.getWriter()`

### getWriter

    public java.io.PrintWriter getWriter()
                                  throws java.io.IOException

  Description copied from interface: `ServletResponse`
  Returns a `PrintWriter` object that can send character text to the client. The character encoding used is the one specified in the `charset=` property of the `ServletResponse.setContentType(java.lang.String)` method, which must be called before calling this method for the charset to take effect.

  If necessary, the MIME type of the response is modified to reflect the character encoding used.

  Calling flush() on the PrintWriter commits the response.

  Either this method or `ServletResponse.getOutputStream()` may be called to write the body, not both.

  Specified by:
    `getWriter` in interface `ServletResponse`
  Returns:
    a `PrintWriter` object that can return character data to the client
  Throws:
    `java.io.IOException` - if an input or output exception occurred
  See Also:
    `ServletResponse.getOutputStream()`, `ServletResponse.setContentType(java.lang.String)`

### setContentLength

    public void setContentLength(int len)

  Description copied from interface: `ServletResponse`
  Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.

  Specified by:
    `setContentLength` in interface `ServletResponse`
  Parameters:
    `len` - an integer specifying the length of the content being returned to the client; sets the Content-Length header

### setContentType

    public void setContentType(java.lang.String contentType)

  Description copied from interface: `ServletResponse`
  Sets the content type of the response being sent to the client. The content type may include the type of character encoding used, for example, `text/html; charset=ISO-8859-4`.

  If obtaining a `PrintWriter`, this method should be called first.

  Specified by:
    `setContentType` in interface `ServletResponse`
  Parameters:
    `contentType` - a `String` specifying the MIME type of the content
  See Also:
    `ServletResponse.getOutputStream()`, `ServletResponse.getWriter()`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### unwrap

    public static ServletHttpResponse unwrap(ServletResponse response)

  Unwrap a ServletResponse.

  Parameters:
    `response` -
  Returns:
    The core ServletHttpResponse which must be the underlying response object
  See Also:
    `ServletResponseWrapper`, `HttpServletResponseWrapper`

Copyright © 2000 Mortbay Consulting Pty. Ltd. All Rights Reserved.